<template>
  <v-container class="pa-0" v-if="flight">
    <FlightsEditFlightForm :flight="flight" class="mb-4" />

  <Teleport to="#teleports">
    <v-toolbar tag="footer" class="footer-action-toolbar" color="white">
      <v-spacer></v-spacer>
      <v-btn variant="outlined" data-cy="FlightFormAddLegBtn" rounded size="large"
        :disabled="!meta.valid || (flight.legs && flight.legs.length > 4) || loading || flight.archived" @click="addLeg"
        class="mr-4 text-uppercase">
        <v-icon left>add</v-icon>
        Ajouter leg
      </v-btn>
      <v-btn variant="outlined" data-cy="FlightFormOkBtn" :disabled="!meta.valid || flight.archived"
        class="inverted text-uppercase" rounded :loading="loading" @click="askCreateEditFlight" size="large">
        Valider
      </v-btn>
    </v-toolbar>
  </Teleport>

    <LazyConfirmDialog v-if="changeAircraftDialog" v-model="changeAircraftDialog" :dialogText="changeAircraftDialogText"
      :dialogTitle="changeAircraftDialogTitle" @confirm="createEditFlight" @close="changeAircraftDialog = false" />
  </v-container>
</template>

<script setup lang="ts">
import { Leg } from "~/dto/leg.dto";
import { Flight } from "~/dto/flight.dto";
import { Aircraft } from "~/dto/aircraft.dto";

const props = defineProps<{ flight: Flight }>()

const { $api, $toast } = useNuxtApp();

const { validate, resetForm, meta } = useForm({
  initialValues: props.flight
})

const isDirty = computed(() => meta.value.dirty)
defineExpose({
  isDirty
})

const originalAircraft: Ref<Aircraft | null> = ref(null);
const changeAircraftDialog = ref(false);
const loading = ref(false);

const changeAircraftDialogTitle = `Changement d'information de vol`;
const changeAircraftDialogText = `Le changement d'un des champs entraîne la suppression des documents avions déjà générés. La suppression d'un leg existant entraîne la suppression des PAXs et Animaux. Êtes-vous sûr de vouloir continuer ?`;

const addLeg = async (onInit = false) => {
  const valid = Boolean(onInit || await validate());
  if (!valid || (props.flight.legs && props.flight.legs.length > 4)) {
    return;
  }
  const leg = new Leg();
  if (props.flight.legs && props.flight.legs.length > 0) {
    leg.departure = props.flight.legs[props.flight.legs.length - 1].arrival;
  }
  props.flight.legs ? props.flight.legs.push(leg) : props.flight.legs = [leg];
  setTimeout(() => {
    window.scrollTo({ top: document.body.scrollHeight, behavior: 'smooth' });
  }, 200);
}

const askCreateEditFlight = () => {
  if (!originalAircraft.value || !originalAircraft.value.name || originalAircraft.value.name === props.flight.aircraft.name) {
    return createEditFlight();
  }
  changeAircraftDialog.value = true;
}

const createEditFlight = async () => {
  try {
    loading.value = true;
    const flightReturned: Flight = props.flight.id ? await $api.flightPaginated.update(formatFlight(props.flight), props.flight.id)
      : await $api.flightPaginated.create(formatFlight(props.flight));
    $toast.success(props.flight.id ? "Vol modifié" : "Vol créé");
    originalAircraft.value = { ...flightReturned.aircraft };

    resetForm({
      values: props.flight,
    });

    if (!props.flight.id && flightReturned.id) {
      navigateTo({ path: `/vols/${flightReturned.id}` });
    } else {
      props.flight.documents = await $api.flightPaginated.getDocuments(props.flight.id);
      await Promise.all(props.flight.legs.map(async (leg: Leg) => {
        if (!leg.id) {
          const newLeg = flightReturned.legs.find((l: Leg) =>
            l.departure.id === leg.departure.id &&
            l.arrival.id === leg.arrival.id
          );
          // @ts-expect-error
          leg.id = newLeg ? newLeg.id : null;
        }
        leg.status = await $api.leg.getStatus(leg.id);
        leg.documents = await $api.leg.getDocuments(leg.id);
      }));
    }
  } catch (e) {
    $toast.error(props.flight.id ? "Erreur lors de l'édition d'un vol" : "Erreur lors de la création d'un vol");
  }
  changeAircraftDialog.value = false;
  loading.value = false;
}

const formatFlight = (flight: Flight) => {
  const flightToReturn = JSON.parse(JSON.stringify(flight));
  delete flightToReturn.aircraft?.seatsTemplate;
  delete flightToReturn.paxs;
  delete flightToReturn.animals;
  flightToReturn.legs.map((l: Leg) => {
    delete l.paxs;
    delete l.animals;
    delete l.seats;
    l.departureTime = new Date(l.departureTime!)
    return l;
  });
  if (flightToReturn.aircraft?.name !== 'Free Seating') {
    flightToReturn.aircraftName = null;
    flightToReturn.aircraftId = null;
  } else {
    flightToReturn.aircraft = null;
  }
  return flightToReturn;
}

onMounted(() => {
  if (props.flight && !props.flight.id) {
    addLeg(true);
  }
  if (props.flight && props.flight.id && !props.flight.aircraft) {
    // @ts-ignore
    props.flight.aircraft = { name: 'Free Seating' };
  }
  originalAircraft.value = { ...props.flight.aircraft };
})

</script>
